/**
 * 
 */
package DDLSHardware;

import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JFrame;

import DDLSSoftware.DDLSController;
import DDLSSoftware.DDLSViewIF;

/**
 * @author dayoung
 *
 */
public class DDLSSwingView extends JFrame implements DDLSViewIF {
	
	private HardwareModel model = null;
	private DDLSController controller = null;
	
	Container contentPane;
	
	private JButton[] numButton = new JButton[10];
	private JButton lockButton = new JButton();
	private JButton keySensor = new JButton();
	
	private JButton door = new JButton();
	private JButton cover = new JButton();
	
	private JButton backlight = new JButton();
	private JButton alarm1 = new JButton();
	private JButton alarm2 = new JButton();
	private JButton alarm3 = new JButton();
	private JButton lockDevice = new JButton();
	
	ActionListener myActionListener = new ActionListener() {
		
		@Override
		public void actionPerformed(ActionEvent e) {
			// TODO Auto-generated method stub
			Object source = e.getSource();
			INPUT input = null;
			if(model.isCoverOpen()){
				if(source == numButton[0]){
					input = INPUT.INPUT_0;
				}
				if(source == numButton[1]){
					input = INPUT.INPUT_1;
				}
				if(source == numButton[2]){
					input = INPUT.INPUT_2;
				}
				if(source == numButton[3]){
					input = INPUT.INPUT_3;
				}
				if(source == numButton[4]){
					input = INPUT.INPUT_4;
				}
				if(source == numButton[5]){
					input = INPUT.INPUT_5;
				}
				if(source == numButton[6]){
					input = INPUT.INPUT_6;
				}
				if(source == numButton[7]){
					input = INPUT.INPUT_7;
				}
				if(source == numButton[8]){
					input = INPUT.INPUT_8;
				}
				if(source == numButton[9]){
					input = INPUT.INPUT_9;
				}
			}
			if(source == lockButton){
				input = INPUT.INPUT_LOCK_BUTTON;
			}
			if(source == keySensor){
				input = INPUT.INPUT_KEY_SENSOR;
			}
			if(source == cover){
				if(model.isCoverOpen()){
					input = INPUT.INPUT_COVER_SENSOR;
					model.closeCover();
				}
				else{
					model.openCover();
				}
			}
			if(source == door){
				input = INPUT.INPUT_DOOR_SENSOR;
				if(model.isDoorOpen()){
					model.closeDoor();
				}
				else{
					model.openDoor();
				}
			}
			if(input != null){
				controller.getInput(input);
			}
		}
	};
	public DDLSSwingView(){
		setTitle("Ʈ  DDLS");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		contentPane = getContentPane();
		contentPane.setLayout(new FlowLayout());
		setSize(250,350);
		setVisible(true);
		
		for(int i = 0; i<10 ; i++){
			numButton[i] = new JButton();
			numButton[i].setText(Integer.toString(i));
			numButton[i].addActionListener(myActionListener);
			contentPane.add(numButton[i]);
		}
		lockButton.setText("lock button");
		lockButton.addActionListener(myActionListener);
		contentPane.add(lockButton);
		keySensor.setText("key Sensor");
		keySensor.addActionListener(myActionListener);
		contentPane.add(keySensor);
		
		cover.addActionListener(myActionListener);
		contentPane.add(cover);
		door.addActionListener(myActionListener);
		contentPane.add(door);		
		backlight.addActionListener(myActionListener);
		contentPane.add(backlight);
		alarm1.addActionListener(myActionListener);
		contentPane.add(alarm1);
		alarm2.addActionListener(myActionListener);
		contentPane.add(alarm2);
		alarm3.addActionListener(myActionListener);
		contentPane.add(alarm3);
		lockDevice.addActionListener(myActionListener);
		contentPane.add(lockDevice);
	}
	public void setModel(HardwareModel model){
		this.model = model;
		update();
	}
	@Override
	public void setCotroller(DDLSController controller) {
		this.controller = controller;
	}

	/* (non-Javadoc)
	 * @see DDLSSoftware.DDLSViewIF#update()
	 */
	@Override
	public void update() {
		// TODO Auto-generated method stub
		//cover door backlight alarm1 2 3 lockDevice
		if(model.isCoverOpen()){
			cover.setText("cover open");
		}
		else{
			cover.setText("cover close");
		}
		if(model.isDoorOpen()){
			door.setText("door open");
		}
		else{
			door.setText("door close");
		}
		if(model.getBacklight()){
			backlight.setText("backlight on");
		}
		else{
			backlight.setText("backlight off");
		}
		if(model.getAlarm1()){
			alarm1.setText("alarm1 on");
		}
		else{
			alarm1.setText("alarm1 off");
		}
		if(model.getAlarm2()){
			alarm2.setText("alarm2 on");
		}
		else{
			alarm2.setText("alarm2 off");
		}
		if(model.getAlarm3()){
			alarm3.setText("alarm3 on");
		}
		else{
			alarm3.setText("alarm3 off");
		}
		if(model.getLockDevice()){
			lockDevice.setText("lock open");
		}
		else{
			lockDevice.setText("lock close");
		}
	}

	/* (non-Javadoc)
	 * @see DDLSSoftware.DDLSViewIF#onClick()
	 */
	@Override
	public void onClick() {
		// TODO Auto-generated method stub
		
	}
	
}
